package com.huimv.guowei.admin.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.common.utils.ResultCode;
import com.huimv.guowei.admin.entity.BaseDuckInfo;
import com.huimv.guowei.admin.entity.Batch;
import com.huimv.guowei.admin.entity.vo.BatchVo;
import com.huimv.guowei.admin.mapper.BaseDuckInfoMapper;
import com.huimv.guowei.admin.mapper.BatchMapper;
import com.huimv.guowei.admin.service.IBatchService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 代次号 服务实现类
 * </p>
 *
 * @author author
 * @since 2023-11-28
 */
@Service
public class BatchServiceImpl extends ServiceImpl<BatchMapper, Batch> implements IBatchService {

    @Autowired
    private BatchMapper batchMapper;
    @Autowired
    private BaseDuckInfoMapper infoMapper;
    @Override
    public Result list(HttpServletRequest httpServletRequest, Map<String, String> paramsMap) {
        String farmId = paramsMap.get("farmId");
        QueryWrapper<Batch> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("farm_id", farmId);
        List<Batch> batches = batchMapper.selectList(queryWrapper);
        List<BatchVo> list = new ArrayList<>();
        for (Batch batch : batches) {
            QueryWrapper<BaseDuckInfo> queryWrapper1 = new QueryWrapper<>();
            queryWrapper1.eq("farm_id", farmId).eq("batch_num", batch.getBatchNum());
            Integer count = infoMapper.selectCount(queryWrapper1);
            BatchVo batchVo = new BatchVo();
            BeanUtil.copyProperties(batch, batchVo);
            batchVo.setCount(count);
            list.add(batchVo);
        }
        String pageNum = paramsMap.get("pageNum");
        String pageSize = paramsMap.get("pageSize");
        if (pageNum == null || "".equals(pageNum)) {
            pageNum = "1";
        }
        if (pageSize == null || "".equals(pageSize)) {
            pageSize = "10";
        }
        int page = Integer.parseInt(pageNum);//相当于pageNo-------分页中的pi
        int count = Integer.parseInt(pageSize);//相当于pageSize-------分页中的ps
        int size = list.size();
        int pageCount=size/count;
        int fromIndex = count * (page - 1);
        int toIndex = fromIndex + count;
        if (toIndex >= size) {
            toIndex = size;
        }
        if(page>pageCount+1){
            fromIndex=0;
            toIndex=0;
        }
        return new Result(ResultCode.SUCCESS, list.subList(fromIndex, toIndex));
    }
}
